/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#include "JSClientRect.h"

#include <wtf/GetPtr.h>

#include "ClientRect.h"

#include <runtime/JSNumberCell.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSClientRect);

/* Hash table */

static const HashTableValue JSClientRectTableValues[8] =
{
    { "top", DontDelete|ReadOnly, (intptr_t)jsClientRectTop, (intptr_t)0 },
    { "right", DontDelete|ReadOnly, (intptr_t)jsClientRectRight, (intptr_t)0 },
    { "bottom", DontDelete|ReadOnly, (intptr_t)jsClientRectBottom, (intptr_t)0 },
    { "left", DontDelete|ReadOnly, (intptr_t)jsClientRectLeft, (intptr_t)0 },
    { "width", DontDelete|ReadOnly, (intptr_t)jsClientRectWidth, (intptr_t)0 },
    { "height", DontDelete|ReadOnly, (intptr_t)jsClientRectHeight, (intptr_t)0 },
    { "constructor", DontEnum|ReadOnly, (intptr_t)jsClientRectConstructor, (intptr_t)0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSClientRectTable =
#if ENABLE(PERFECT_HASH_SIZE)
    { 255, JSClientRectTableValues, 0 };
#else
    { 18, 15, JSClientRectTableValues, 0 };
#endif

/* Hash table for constructor */

static const HashTableValue JSClientRectConstructorTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSClientRectConstructorTable =
#if ENABLE(PERFECT_HASH_SIZE)
    { 0, JSClientRectConstructorTableValues, 0 };
#else
    { 1, 0, JSClientRectConstructorTableValues, 0 };
#endif

class JSClientRectConstructor : public DOMObject {
public:
    JSClientRectConstructor(ExecState* exec)
        : DOMObject(JSClientRectConstructor::createStructure(exec->lexicalGlobalObject()->objectPrototype()))
    {
        putDirect(exec->propertyNames().prototype, JSClientRectPrototype::self(exec), None);
    }
    virtual bool getOwnPropertySlot(ExecState*, const Identifier&, PropertySlot&);
    virtual const ClassInfo* classInfo() const { return &s_info; }
    static const ClassInfo s_info;

    static PassRefPtr<Structure> createStructure(JSValuePtr proto) 
    { 
        return Structure::create(proto, TypeInfo(ObjectType, ImplementsHasInstance)); 
    }
};

const ClassInfo JSClientRectConstructor::s_info = { "ClientRectConstructor", 0, &JSClientRectConstructorTable, 0 };

bool JSClientRectConstructor::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSClientRectConstructor, DOMObject>(exec, &JSClientRectConstructorTable, this, propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSClientRectPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSClientRectPrototypeTable =
#if ENABLE(PERFECT_HASH_SIZE)
    { 0, JSClientRectPrototypeTableValues, 0 };
#else
    { 1, 0, JSClientRectPrototypeTableValues, 0 };
#endif

const ClassInfo JSClientRectPrototype::s_info = { "ClientRectPrototype", 0, &JSClientRectPrototypeTable, 0 };

JSObject* JSClientRectPrototype::self(ExecState* exec)
{
    return getDOMPrototype<JSClientRect>(exec);
}

const ClassInfo JSClientRect::s_info = { "ClientRect", 0, &JSClientRectTable, 0 };

JSClientRect::JSClientRect(PassRefPtr<Structure> structure, PassRefPtr<ClientRect> impl)
    : DOMObject(structure)
    , m_impl(impl)
{
}

JSClientRect::~JSClientRect()
{
    forgetDOMObject(*Heap::heap(this)->globalData(), m_impl.get());

}

JSObject* JSClientRect::createPrototype(ExecState* exec)
{
    return new (exec) JSClientRectPrototype(JSClientRectPrototype::createStructure(exec->lexicalGlobalObject()->objectPrototype()));
}

bool JSClientRect::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSClientRect, Base>(exec, &JSClientRectTable, this, propertyName, slot);
}

JSValuePtr jsClientRectTop(ExecState* exec, const Identifier&, const PropertySlot& slot)
{
    UNUSED_PARAM(exec);
    ClientRect* imp = static_cast<ClientRect*>(static_cast<JSClientRect*>(asObject(slot.slotBase()))->impl());
    return jsNumber(exec, imp->top());
}

JSValuePtr jsClientRectRight(ExecState* exec, const Identifier&, const PropertySlot& slot)
{
    UNUSED_PARAM(exec);
    ClientRect* imp = static_cast<ClientRect*>(static_cast<JSClientRect*>(asObject(slot.slotBase()))->impl());
    return jsNumber(exec, imp->right());
}

JSValuePtr jsClientRectBottom(ExecState* exec, const Identifier&, const PropertySlot& slot)
{
    UNUSED_PARAM(exec);
    ClientRect* imp = static_cast<ClientRect*>(static_cast<JSClientRect*>(asObject(slot.slotBase()))->impl());
    return jsNumber(exec, imp->bottom());
}

JSValuePtr jsClientRectLeft(ExecState* exec, const Identifier&, const PropertySlot& slot)
{
    UNUSED_PARAM(exec);
    ClientRect* imp = static_cast<ClientRect*>(static_cast<JSClientRect*>(asObject(slot.slotBase()))->impl());
    return jsNumber(exec, imp->left());
}

JSValuePtr jsClientRectWidth(ExecState* exec, const Identifier&, const PropertySlot& slot)
{
    UNUSED_PARAM(exec);
    ClientRect* imp = static_cast<ClientRect*>(static_cast<JSClientRect*>(asObject(slot.slotBase()))->impl());
    return jsNumber(exec, imp->width());
}

JSValuePtr jsClientRectHeight(ExecState* exec, const Identifier&, const PropertySlot& slot)
{
    UNUSED_PARAM(exec);
    ClientRect* imp = static_cast<ClientRect*>(static_cast<JSClientRect*>(asObject(slot.slotBase()))->impl());
    return jsNumber(exec, imp->height());
}

JSValuePtr jsClientRectConstructor(ExecState* exec, const Identifier&, const PropertySlot& slot)
{
    return static_cast<JSClientRect*>(asObject(slot.slotBase()))->getConstructor(exec);
}
JSValuePtr JSClientRect::getConstructor(ExecState* exec)
{
    return getDOMConstructor<JSClientRectConstructor>(exec);
}

JSC::JSValuePtr toJS(JSC::ExecState* exec, ClientRect* object)
{
    return getDOMObjectWrapper<JSClientRect>(exec, object);
}
ClientRect* toClientRect(JSC::JSValuePtr value)
{
    return value.isObject(&JSClientRect::s_info) ? static_cast<JSClientRect*>(asObject(value))->impl() : 0;
}

}
