/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#include "JSInspectorController.h"

#include <wtf/GetPtr.h>

#include "DOMWindow.h"
#include "InspectorController.h"
#include "KURL.h"
#include "Node.h"

#include <runtime/Error.h>
#include <runtime/JSNumberCell.h>
#include <runtime/JSString.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSInspectorController);

/* Hash table */

static const HashTableValue JSInspectorControllerTableValues[2] =
{
    { "constructor", DontEnum|ReadOnly, (intptr_t)jsInspectorControllerConstructor, (intptr_t)0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSInspectorControllerTable =
#if ENABLE(PERFECT_HASH_SIZE)
    { 0, JSInspectorControllerTableValues, 0 };
#else
    { 2, 1, JSInspectorControllerTableValues, 0 };
#endif

/* Hash table for constructor */

static const HashTableValue JSInspectorControllerConstructorTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSInspectorControllerConstructorTable =
#if ENABLE(PERFECT_HASH_SIZE)
    { 0, JSInspectorControllerConstructorTableValues, 0 };
#else
    { 1, 0, JSInspectorControllerConstructorTableValues, 0 };
#endif

class JSInspectorControllerConstructor : public DOMObject {
public:
    JSInspectorControllerConstructor(ExecState* exec)
        : DOMObject(JSInspectorControllerConstructor::createStructure(exec->lexicalGlobalObject()->objectPrototype()))
    {
        putDirect(exec->propertyNames().prototype, JSInspectorControllerPrototype::self(exec), None);
    }
    virtual bool getOwnPropertySlot(ExecState*, const Identifier&, PropertySlot&);
    virtual const ClassInfo* classInfo() const { return &s_info; }
    static const ClassInfo s_info;

    static PassRefPtr<Structure> createStructure(JSValuePtr proto) 
    { 
        return Structure::create(proto, TypeInfo(ObjectType, ImplementsHasInstance)); 
    }
};

const ClassInfo JSInspectorControllerConstructor::s_info = { "InspectorControllerConstructor", 0, &JSInspectorControllerConstructorTable, 0 };

bool JSInspectorControllerConstructor::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSInspectorControllerConstructor, DOMObject>(exec, &JSInspectorControllerConstructorTable, this, propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSInspectorControllerPrototypeTableValues[45] =
{
    { "hideDOMNodeHighlight", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionHideDOMNodeHighlight, (intptr_t)0 },
    { "highlightDOMNode", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionHighlightDOMNode, (intptr_t)1 },
    { "loaded", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionLoaded, (intptr_t)0 },
    { "windowUnloading", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionWindowUnloading, (intptr_t)0 },
    { "attach", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionAttach, (intptr_t)0 },
    { "detach", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionDetach, (intptr_t)0 },
    { "enableDebugger", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionEnableDebugger, (intptr_t)0 },
    { "disableDebugger", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionDisableDebugger, (intptr_t)0 },
    { "pauseInDebugger", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionPauseInDebugger, (intptr_t)0 },
    { "resumeDebugger", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionResumeDebugger, (intptr_t)0 },
    { "stepOverStatementInDebugger", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionStepOverStatementInDebugger, (intptr_t)0 },
    { "stepIntoStatementInDebugger", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionStepIntoStatementInDebugger, (intptr_t)0 },
    { "stepOutOfFunctionInDebugger", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionStepOutOfFunctionInDebugger, (intptr_t)0 },
    { "closeWindow", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionCloseWindow, (intptr_t)0 },
    { "clearMessages", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionClearMessages, (intptr_t)0 },
    { "startProfiling", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionStartProfiling, (intptr_t)0 },
    { "stopProfiling", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionStopProfiling, (intptr_t)0 },
    { "enableProfiler", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionEnableProfiler, (intptr_t)0 },
    { "disableProfiler", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionDisableProfiler, (intptr_t)0 },
    { "toggleNodeSearch", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionToggleNodeSearch, (intptr_t)0 },
    { "debuggerEnabled", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionDebuggerEnabled, (intptr_t)0 },
    { "pauseOnExceptions", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionPauseOnExceptions, (intptr_t)0 },
    { "profilerEnabled", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionProfilerEnabled, (intptr_t)0 },
    { "isWindowVisible", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionIsWindowVisible, (intptr_t)0 },
    { "searchingForNode", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionSearchingForNode, (intptr_t)0 },
    { "addResourceSourceToFrame", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionAddResourceSourceToFrame, (intptr_t)2 },
    { "addSourceToFrame", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionAddSourceToFrame, (intptr_t)3 },
    { "getResourceDocumentNode", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionGetResourceDocumentNode, (intptr_t)1 },
    { "search", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionSearch, (intptr_t)2 },
    { "databaseTableNames", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionDatabaseTableNames, (intptr_t)1 },
    { "setting", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionSetting, (intptr_t)1 },
    { "setSetting", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionSetSetting, (intptr_t)2 },
    { "inspectedWindow", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionInspectedWindow, (intptr_t)0 },
    { "localizedStringsURL", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionLocalizedStringsURL, (intptr_t)0 },
    { "hiddenPanels", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionHiddenPanels, (intptr_t)0 },
    { "platform", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionPlatform, (intptr_t)0 },
    { "moveByUnrestricted", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionMoveByUnrestricted, (intptr_t)2 },
    { "setAttachedWindowHeight", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionSetAttachedWindowHeight, (intptr_t)1 },
    { "wrapCallback", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionWrapCallback, (intptr_t)1 },
    { "currentCallFrame", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionCurrentCallFrame, (intptr_t)0 },
    { "setPauseOnExceptions", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionSetPauseOnExceptions, (intptr_t)1 },
    { "addBreakpoint", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionAddBreakpoint, (intptr_t)2 },
    { "removeBreakpoint", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionRemoveBreakpoint, (intptr_t)2 },
    { "profiles", DontDelete|Function, (intptr_t)jsInspectorControllerPrototypeFunctionProfiles, (intptr_t)0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSInspectorControllerPrototypeTable =
#if ENABLE(PERFECT_HASH_SIZE)
    { 2047, JSInspectorControllerPrototypeTableValues, 0 };
#else
    { 135, 127, JSInspectorControllerPrototypeTableValues, 0 };
#endif

const ClassInfo JSInspectorControllerPrototype::s_info = { "InspectorControllerPrototype", 0, &JSInspectorControllerPrototypeTable, 0 };

JSObject* JSInspectorControllerPrototype::self(ExecState* exec)
{
    return getDOMPrototype<JSInspectorController>(exec);
}

bool JSInspectorControllerPrototype::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticFunctionSlot<JSObject>(exec, &JSInspectorControllerPrototypeTable, this, propertyName, slot);
}

const ClassInfo JSInspectorController::s_info = { "InspectorController", 0, &JSInspectorControllerTable, 0 };

JSInspectorController::JSInspectorController(PassRefPtr<Structure> structure, PassRefPtr<InspectorController> impl)
    : DOMObject(structure)
    , m_impl(impl)
{
}

JSInspectorController::~JSInspectorController()
{
    forgetDOMObject(*Heap::heap(this)->globalData(), m_impl.get());

}

JSObject* JSInspectorController::createPrototype(ExecState* exec)
{
    return new (exec) JSInspectorControllerPrototype(JSInspectorControllerPrototype::createStructure(exec->lexicalGlobalObject()->objectPrototype()));
}

bool JSInspectorController::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSInspectorController, Base>(exec, &JSInspectorControllerTable, this, propertyName, slot);
}

JSValuePtr jsInspectorControllerConstructor(ExecState* exec, const Identifier&, const PropertySlot& slot)
{
    return static_cast<JSInspectorController*>(asObject(slot.slotBase()))->getConstructor(exec);
}
JSValuePtr JSInspectorController::getConstructor(ExecState* exec)
{
    return getDOMConstructor<JSInspectorControllerConstructor>(exec);
}

JSValuePtr jsInspectorControllerPrototypeFunctionHideDOMNodeHighlight(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->hideHighlight();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionHighlightDOMNode(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    return castedThisObj->highlightDOMNode(exec, args);
}

JSValuePtr jsInspectorControllerPrototypeFunctionLoaded(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->scriptObjectReady();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionWindowUnloading(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->close();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionAttach(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->attachWindow();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionDetach(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->detachWindow();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionEnableDebugger(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->enableDebugger();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionDisableDebugger(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->disableDebugger();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionPauseInDebugger(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->pauseInDebugger();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionResumeDebugger(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->resumeDebugger();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionStepOverStatementInDebugger(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->stepOverStatementInDebugger();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionStepIntoStatementInDebugger(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->stepIntoStatementInDebugger();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionStepOutOfFunctionInDebugger(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->stepOutOfFunctionInDebugger();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionCloseWindow(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->closeWindow();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionClearMessages(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->clearConsoleMessages();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionStartProfiling(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->startUserInitiatedProfiling();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionStopProfiling(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->stopUserInitiatedProfiling();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionEnableProfiler(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->enableProfiler();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionDisableProfiler(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->disableProfiler();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionToggleNodeSearch(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());

    imp->toggleSearchForNodeInPage();
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionDebuggerEnabled(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());


    JSC::JSValuePtr result = jsBoolean(imp->debuggerEnabled());
    return result;
}

JSValuePtr jsInspectorControllerPrototypeFunctionPauseOnExceptions(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());


    JSC::JSValuePtr result = jsBoolean(imp->pauseOnExceptions());
    return result;
}

JSValuePtr jsInspectorControllerPrototypeFunctionProfilerEnabled(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());


    JSC::JSValuePtr result = jsBoolean(imp->profilerEnabled());
    return result;
}

JSValuePtr jsInspectorControllerPrototypeFunctionIsWindowVisible(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());


    JSC::JSValuePtr result = jsBoolean(imp->windowVisible());
    return result;
}

JSValuePtr jsInspectorControllerPrototypeFunctionSearchingForNode(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());


    JSC::JSValuePtr result = jsBoolean(imp->searchingForNodeInPage());
    return result;
}

JSValuePtr jsInspectorControllerPrototypeFunctionAddResourceSourceToFrame(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    return castedThisObj->addResourceSourceToFrame(exec, args);
}

JSValuePtr jsInspectorControllerPrototypeFunctionAddSourceToFrame(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    return castedThisObj->addSourceToFrame(exec, args);
}

JSValuePtr jsInspectorControllerPrototypeFunctionGetResourceDocumentNode(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    return castedThisObj->getResourceDocumentNode(exec, args);
}

JSValuePtr jsInspectorControllerPrototypeFunctionSearch(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    return castedThisObj->search(exec, args);
}

JSValuePtr jsInspectorControllerPrototypeFunctionDatabaseTableNames(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    return castedThisObj->databaseTableNames(exec, args);
}

JSValuePtr jsInspectorControllerPrototypeFunctionSetting(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    return castedThisObj->setting(exec, args);
}

JSValuePtr jsInspectorControllerPrototypeFunctionSetSetting(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    return castedThisObj->setSetting(exec, args);
}

JSValuePtr jsInspectorControllerPrototypeFunctionInspectedWindow(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    return castedThisObj->inspectedWindow(exec, args);
}

JSValuePtr jsInspectorControllerPrototypeFunctionLocalizedStringsURL(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());


    JSC::JSValuePtr result = jsString(exec, imp->localizedStringsURL());
    return result;
}

JSValuePtr jsInspectorControllerPrototypeFunctionHiddenPanels(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());


    JSC::JSValuePtr result = jsString(exec, imp->hiddenPanels());
    return result;
}

JSValuePtr jsInspectorControllerPrototypeFunctionPlatform(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());


    JSC::JSValuePtr result = jsString(exec, imp->platform());
    return result;
}

JSValuePtr jsInspectorControllerPrototypeFunctionMoveByUnrestricted(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());
    float x = args.at(exec, 0).toFloat(exec);
    float y = args.at(exec, 1).toFloat(exec);

    imp->moveWindowBy(x, y);
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionSetAttachedWindowHeight(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());
    unsigned height = args.at(exec, 0).toInt32(exec);

    imp->setAttachedWindowHeight(height);
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionWrapCallback(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    return castedThisObj->wrapCallback(exec, args);
}

JSValuePtr jsInspectorControllerPrototypeFunctionCurrentCallFrame(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    return castedThisObj->currentCallFrame(exec, args);
}

JSValuePtr jsInspectorControllerPrototypeFunctionSetPauseOnExceptions(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());
    bool pauseOnExceptions = args.at(exec, 0).toBoolean(exec);

    imp->setPauseOnExceptions(pauseOnExceptions);
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionAddBreakpoint(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());
    unsigned sourceID = args.at(exec, 0).toInt32(exec);
    unsigned lineNumber = args.at(exec, 1).toInt32(exec);

    imp->addBreakpoint(sourceID, lineNumber);
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionRemoveBreakpoint(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    InspectorController* imp = static_cast<InspectorController*>(castedThisObj->impl());
    unsigned sourceID = args.at(exec, 0).toInt32(exec);
    unsigned lineNumber = args.at(exec, 1).toInt32(exec);

    imp->removeBreakpoint(sourceID, lineNumber);
    return jsUndefined();
}

JSValuePtr jsInspectorControllerPrototypeFunctionProfiles(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSInspectorController::s_info))
        return throwError(exec, TypeError);
    JSInspectorController* castedThisObj = static_cast<JSInspectorController*>(asObject(thisValue));
    return castedThisObj->profiles(exec, args);
}

JSC::JSValuePtr toJS(JSC::ExecState* exec, InspectorController* object)
{
    return getDOMObjectWrapper<JSInspectorController>(exec, object);
}
InspectorController* toInspectorController(JSC::JSValuePtr value)
{
    return value.isObject(&JSInspectorController::s_info) ? static_cast<JSInspectorController*>(asObject(value))->impl() : 0;
}

}
