/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#include "JSVoidCallback.h"

#include <wtf/GetPtr.h>

#include "VoidCallback.h"

#include <runtime/Error.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSVoidCallback);

/* Hash table for prototype */

static const HashTableValue JSVoidCallbackPrototypeTableValues[2] =
{
    { "handleEvent", DontDelete|Function, (intptr_t)jsVoidCallbackPrototypeFunctionHandleEvent, (intptr_t)0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSVoidCallbackPrototypeTable =
#if ENABLE(PERFECT_HASH_SIZE)
    { 0, JSVoidCallbackPrototypeTableValues, 0 };
#else
    { 2, 1, JSVoidCallbackPrototypeTableValues, 0 };
#endif

const ClassInfo JSVoidCallbackPrototype::s_info = { "VoidCallbackPrototype", 0, &JSVoidCallbackPrototypeTable, 0 };

JSObject* JSVoidCallbackPrototype::self(ExecState* exec)
{
    return getDOMPrototype<JSVoidCallback>(exec);
}

bool JSVoidCallbackPrototype::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticFunctionSlot<JSObject>(exec, &JSVoidCallbackPrototypeTable, this, propertyName, slot);
}

const ClassInfo JSVoidCallback::s_info = { "VoidCallback", 0, 0, 0 };

JSVoidCallback::JSVoidCallback(PassRefPtr<Structure> structure, PassRefPtr<VoidCallback> impl)
    : DOMObject(structure)
    , m_impl(impl)
{
}

JSVoidCallback::~JSVoidCallback()
{
    forgetDOMObject(*Heap::heap(this)->globalData(), m_impl.get());

}

JSObject* JSVoidCallback::createPrototype(ExecState* exec)
{
    return new (exec) JSVoidCallbackPrototype(JSVoidCallbackPrototype::createStructure(exec->lexicalGlobalObject()->objectPrototype()));
}

JSValuePtr jsVoidCallbackPrototypeFunctionHandleEvent(ExecState* exec, JSObject*, JSValuePtr thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.isObject(&JSVoidCallback::s_info))
        return throwError(exec, TypeError);
    JSVoidCallback* castedThisObj = static_cast<JSVoidCallback*>(asObject(thisValue));
    VoidCallback* imp = static_cast<VoidCallback*>(castedThisObj->impl());

    imp->handleEvent();
    return jsUndefined();
}

JSC::JSValuePtr toJS(JSC::ExecState* exec, VoidCallback* object)
{
    return getDOMObjectWrapper<JSVoidCallback>(exec, object);
}

}
